#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		__python	/usr/bin/python3
#-----------------------------------------------------------------------------
Name		:	bitcoin
Version		:	25.0
Release		:	16.2.1.rel%{?dist}
Summary		:	A peer-to-peer network based digital currency 
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://github.com/bitcoin/bitcoin/tags

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	boost-devel
BuildRequires	:	libevent
BuildRequires	:	libqrencode
BuildRequires	:	qt

Requires(post)	:	%{_bindir}/update-desktop-database
#-----------------------------------------------------------------------------
%description
Bitcoin is an experimental digital currency that enables
instant payments to anyone, anywhere in the world.
Bitcoin uses peer-to-peer technology to operate with no
central authority: managing transactions and issuing money
are carried out collectively by the network. Bitcoin Core
is the name of open source software which enables the use
of this currency.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING doc/README.md doc/shared-libraries.md
%license COPYING
%{_libdir}/lib%{name}consensus.so.*

#=============================================================================
%package		devel
Summary		:	Development files for bitcoin

#-----------------------------------------------------------------------------
Requires	:       %{name}	 = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains the header files and static
library for the bitcoinconsensus shared library. If
you are developing or compiling software that wants
to link against that library, then you need this
package installed.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%license COPYING
%doc COPYING doc/README.md doc/developer-notes.md doc/shared-libraries.md
%attr(0644,root,root) %{_includedir}/%{name}*.h
%{_bindir}/%{name}-util
%{_libdir}/lib%{name}consensus.so
%attr(0644,root,root) %{_libdir}/pkgconfig/lib%{name}consensus.pc
%{_mandir}/man1/%{name}-util.1.gz

#=============================================================================
%package		qt
Summary		:	GUI for a peer-to-peer network based digital currency

#-----------------------------------------------------------------------------
BuildRequires	:	desktop-file-utils

Requires	:       %{name}	 = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		qt
This package contains the Qt based graphical client and node.
If you are looking to run a Bitcoin wallet, this is
probably the package you want.

#-----------------------------------------------------------------------------
%files			qt
%defattr(-,root,root,-)
%license COPYING
%doc COPYING doc/README.md doc/bips.md doc/files.md
%doc doc/reduce-traffic.md doc/release-notes.md doc/tor.md
%attr(0755,root,root) %{_bindir}/%{name}-qt
%attr(0644,root,root) %{_datadir}/applications/%{name}-qt.desktop
%attr(0644,root,root) %{_datadir}/pixmaps/*.ico
%attr(0644,root,root) %{_mandir}/man1/bitcoin-qt.1.gz


#=============================================================================
%package		daemon
Summary		:	Bitcoin Daemon server

#-----------------------------------------------------------------------------
Requires	:       %{name}	 = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		daemon
This package provides a stand-alone bitcoin daemon.
For most users, this package is only needed if they
need a full-node without the graphical client.

#-----------------------------------------------------------------------------
%files			daemon
%defattr(-,root,root,-)
%license COPYING
%doc COPYING doc/README.md doc/REST-interface.md doc/bips.md
%doc doc/dnsseed-policy.md doc/files.md doc/reduce-traffic.md
%doc doc/release-notes.md doc/tor.md
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/bitcoin.conf
%attr(0644,root,root) %{_sysconfdir}/rc.d/init.d/%{name}d
%attr(0700,bitcoin,bitcoin) %{_sharedstatedir}/bitcoin
%attr(0755,root,root) %{_bindir}/bitcoind
%attr(0644,root,root) %{_datadir}/bitcoin/rpcauth.py
%attr(0644,root,root) %{_mandir}/man1/bitcoind.1.gz

#-----------------------------------------------------------------------------
#before to install
%pre			daemon
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

  /usr/sbin/useradd 				\
	-r					\
	-c "Privilege-separated bitcoin"	\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{_sharedstatedir}/%{name}		\
	%{name}
  fi

#after upgrade or remove
%preun			daemon
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name}d stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}d
  /usr/sbin/userdel %{name}
  /usr/sbin/groupdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post			daemon
/sbin/chkconfig --add %{name}d
%{_sysconfdir}/rc.d/init.d/%{name}d condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		cli
Summary		:	Bitcoin clommand line interface

#-----------------------------------------------------------------------------
Requires	:       %{name}	 = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		cli
This package installs command line programs like bitcoin-cli
and bitcoin-tx that can be used to interact with the bitcoin
daemon.

#-----------------------------------------------------------------------------
%files			cli
%defattr(-,root,root,-)
%license COPYING
%attr(0755,root,root) %{_bindir}/%{name}-cli
%attr(0755,root,root) %{_bindir}/%{name}-tx
%attr(0755,root,root) %{_bindir}/%{name}-wallet
%attr(0644,root,root) %{_mandir}/man1/%{name}-wallet.1.gz
%attr(0644,root,root) %{_mandir}/man1/%{name}-cli.1.gz
%attr(0644,root,root) %{_mandir}/man1/%{name}-tx.1.gz

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}
autoreconf -vfi

#-----------------------------------------------------------------------------
#building application
%build

./configure							\
        --prefix=%{_prefix}					\
        --includedir=%{_includedir}				\
	--exec-prefix=%{_exec_prefix}				\
        --sysconfdir=%{_sysconfdir}				\
        --sbindir=%{_sbindir}					\
	--mandir=%{_mandir}					\
	--libdir=%{_libdir}					\
	--infodir=%{_infodir}					\
	--docdir=%{_defaultdocdir}/%{name}-%{version}		\
	--disable-bench						\
	--with-gui=qt5						\
	--with-incompatible-bdb					\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}							\
	DESTDIR=%{buildroot}					\
	install

#installing bitcoind starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 							\
	%{name}-ok_addon/%{name}d				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

install -p							\
	%{name}-ok_addon/%{name}.conf				\
	%{buildroot}%{_sysconfdir}/%{name}.conf

%{__mkdir_p}							\
	%{buildroot}%{_datadir}/%{name}	
install -p							\
	share/rpcauth/rpcauth.py				\
	%{buildroot}/%{_datadir}/%{name}/rpcauth.py

%{__mkdir_p}							\
	%{buildroot}%{_datadir}/pixmap
install -D -p							\
	share/pixmaps/bitcoin.ico				\
	%{buildroot}%{_datadir}/pixmaps/bitcoin.ico

desktop-file-install						\
	%{name}-ok_addon/%{name}-qt.desktop			\
	%{buildroot}%{_datadir}/applications/%{name}-qt.desktop

%{__mkdir_p}							\
	%{buildroot}%{_sharedstatedir}/%{name}	

# no need to generate debuginfo data for the test executables
%{__rm} -f							\
	 %{buildroot}%{_bindir}/test_%{name}*

#To remove libtool library and static library
find 								\
	%{buildroot}%{_libdir}					\
	\(							\
		 -name \*.la					\
		 -o						\
		 -name \*.a					\
	 \)							\
	-delete

#-----------------------------------------------------------------------------
%changelog
